<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Web - jQuery</title>
    <script src="./static/script.js"></script>
    <script src="./static/js/jquery-3.6.0.min.js"></script>
</head>
<body>
    <h1>Hello World</h1>
    <p> This is my website</p>
    <button id="btn_hello" onClick="alertMsg()">通知</button>
    <button id="btn_google" onClick="visitWeb()">訪問</button> 
    <button id="btn_click">點擊</button>
    <p id=console>count : 0</p>

    <script>
        var $btnClick = $('#btn_click');
        var $console = $('#console');
        var count = 0;

        $btnClick.off('click').on('click' , function(){
            count++;
            $console.text("count : " + count);
        })
    </script>

    <hr>
    <h2>Diff : JavaScript vs jQuery</h2>
    <button id="btn-01">Modify Text (Javascript)</button>
    <button id="btn-02">Modify Text (jQuery)</button>

    <script type="text/JavaScript">
        var btn01 = document.getElementById("btn-01");
        btn01.addEventListener('click',function(){
           var console=document.getElementById("console");
           console.innerHTML = "Modify Text (Javascript)";
        });
    
        var btn02 = $("#btn-02");
        btn02.on("click" , function(){
            $("#console").html("Modify Text (jQuery)")
        });
    </script>
    <hr>
    <h2>JavaScript 基礎</h2>
    <h3>變數 (variable)</h3>
    <div id="variable">
    </div>
    <script>
        var str = "Text"; // String
        var num = 10; // Integer
        var point = 10.05; // Float
        var isCorrect = true; // true,1,"msg" / false,0,""
        var lstNum = [1,2,3,4,5]; // Array
        var lstStr = ["A" , "B" , "C"];
        var appInfo = { // Object
            id : 1 , 
            name : "jQuerySE" ,
            author : "DevAuth" ,
            version : "1.0.1" ,
            remark : "jQuery - Sample Example"
        }
        appInfo.id = 2;
        appInfo.version = "1.0.2";

        $('#variable').append("<ul>");
        $('#variable').append("<li> str : " + str + "</li>");
        $('#variable').append("<li> num : " + num + "</li>");
        $('#variable').append("<li> point : " + point + "</li>");
        $('#variable').append("<li> isCorrect : " + isCorrect + "</li>");
        $('#variable').append("<ul>");
        $('#variable').append("<p>lstNum : </p>");
        for(var i=0;i<lstNum.length;i++){
            $('#variable').append(lstNum[i]);
            if(i < lstNum.length - 1 ){
                $('#variable').append(' , ');
            }
        }
        $('#variable').append("<p>lstStr : </p>");
        for(var i=0;i<lstStr.length;i++){
            $('#variable').append(lstStr[i])
            if(i < lstNum.length - 1 ){
                $('#variable').append(' , ');
            }
        }
        $('#variable').append("<p>appInfo : </p>");
        $('#variable').append("appInfo.id : " + appInfo.id + "<br>");
        $('#variable').append("appInfo.name : " + appInfo.name + "<br>");
        $('#variable').append("appInfo.version : " + appInfo.version + "<br>");
    </script>
    
    <h3>函式 (function)</h3>
    <div>
        <button id="btnShowMsg01">Show Message 01</button>
        <button id="btnShowMsg02">Show Message 02</button>
        <button id="btnShowMsg03">Show Message 03</button>
    </div>
    <script>
        function showMsg(msg){
            alert(msg);
        }
        var message = function(msg){
            alert(msg);
        }

        $('#btnShowMsg01').off('click').on('click' , alertMsg);
        $('#btnShowMsg02').off('click').on('click' , function(){
            showMsg("Hello World(2)");
        });
        $('#btnShowMsg03').off('click').on('click' , function(){
            message("Hello World(3)")
        });
    </script>
    <hr>
    <h2>jQuery 用法</h2>

    <h3>選擇器 (Selectors)</h3>

    <h4>Title</h4>
    <span data-name="my_name">Name : </span><input type="text" name="text" >
    <button id="btn_action">Button</button>
    <p class=result>Count</p>
    <script>
    var $title = $('h4');
    var $btnAction = $('#btn_action');
    var $result = $('.result');
    var $text = $('[name=text]');
    var $myName = $('[data-name=my_name]');
    count = 0;

    $btnAction.off('click').on('click' , function(){
        count++;
        $title.text("Title(" + count + ")");
        $btnAction.text("Button(" + count + ")");
        $result.text("Count(" + count + ")");
        $myName.text("Name(" + count + ") : ");
        $text.val(count);
    });
    </script>

    <h3>操作元素 (Element)</h3>
    <input type="text" id="input">
    <button id="update" onclick="update()">Update</button><br><br>
    <div id="view">
        <p>View - Element</p>
    </div>
    <script>
        function update() {
            var text = $('#view').text();
            var html = $('#view').text();
            var value = $('#input').val();
            $("#update").text(text);
            $("#view").html("<input id='output' type='text'>&nbsp;<button>New - Element</button>");
            $("#output").val(value);
        }
    </script>

    <h3>操作屬性 (Attributes)</h3>
    <p id="attributes">None</p> 
    <button id=btn_attr>Move</button>
    <script>
        $attr = $('#attributes');
        $btnAttr = $('#btn_attr');
        var lstAction = ["left" , "center" , "right" ];
        $btnAttr.off('click').on('click' , function(){
            count ++;
            action = count % 4;
            switch(action){
                case 0 :
                    $attr.attr('align',lstAction[0]);
                    $attr.text("Left");
                    break;
                case 1 :
                    $attr.attr('align',lstAction[1]);
                    $attr.text('Center');
                    break;
                case 2 :
                    $attr.attr('align',lstAction[2]);
                    break;
                case 3 :
                    $attr.removeAttr('align');
                    $attr.text("None");
                    break;
            }
        });
    </script>
    <h3>操作樣式 (CSS - Style)</h3>
    <img id="img_logo" src="static/img/logo.png" alt=""> 
    <br>
    <button id="btn_modify">Modify</button>
    <button id="btn_remove">Remove</button>
    <button id="btn_toggle">Toggle</button>
    <style>
        .large{
            width : 500px;
            height: 500px;
            background-color: black;
        }
        .medium{
            width: 250px;
            height: 250px;
            background-color: gray;
        }
        .small{
            width: 150px;
            height: 150px;
            background-color: blue;
        }
    </style>
    <script>
    var $imgLogo = $('#img_logo');
    var $btnModify = $('#btn_modify');
    var $btnRemove = $('#btn_remove');
    var $btnToggle = $('#btn_toggle');
    var lstStyle = ["large" , "medium" , "small" ];
    $btnModify.off('click').on('click',function(){
        count ++;
        style = count % 3;
        if ($imgLogo.hasClass(lstStyle[0])){
            $imgLogo.removeClass(lstStyle[0]);
        }
        if ($imgLogo.hasClass(lstStyle[1])){
            $imgLogo.removeClass(lstStyle[1]);
        }
        if ($imgLogo.hasClass(lstStyle[2])){
            $imgLogo.removeClass(lstStyle[2]);
        }
        $imgLogo.addClass(lstStyle[style]);
    });
    $btnRemove.off('click').on('click',function(){
        $imgLogo.removeClass('large');
        $imgLogo.removeClass('medium');
        $imgLogo.removeClass('small');
    });
    $btnToggle.off('click').on('click',function(){
        $imgLogo.toggleClass();
    });
    </script>
    <h3>動作事件 (Event)</h3>
    <button id="button">Button</button>
    <input type="text" id="edit">
    <span id="show" style="background-color: black; color:white;">
        Mouse Event : OUT
    </span>
    <script>
        $('#button').off('click').on('click', function(){
            $('#show').text("Button Event : Click");
        });
        $('#edit').off('change').on('change' , function(){
            var value = $("#edit").val();
            $('#show').text("Change Event : " + value);
        });
        $('#show').off('mouseover').on('mouseover' , function(){
           $('#show').text("Mouse Event : IN ");
        });

        $('#show').off('mouseout').on('mouseout' , function(){
           $('#show').text("Mouse Event : OUT ");
        });
    </script>
    <h3>資料交換 (Ajax)</h3>
    <button id="btnRequest" onclick="requestData()">Request Data</button>
    <div id="result">result : None</div>
    <script>
        function requestData(){
            $.ajax({
                url: "static/data/appInfo.json",
                type: "GET",
                success: function(result) {
                    result = JSON.parse(result);
                    data = result.appInfo;
                    $("#result").html("result : <br>");
                    $("#result").append("id => " + data.id + "<br>");
                    $("#result").append("name => " + data.name + "<br>");
                    $("#result").append("version => " + data.version + "<br>");
                    $("#result").append("author => " + data.author + "<br>");
                    $("#result").append("remark => " + data.remark + "<br>");
                }
            });
        }
    </script>
</body>
</html>
